#include <iostream>
using namespace std;

void listar(float v[], int n);
void inserirCresc(float v[], int &n, int max, float valor);
int buscaBinaria(float v[], int n, float valor);
void remover(float v[], int &n, float valor);

int main(void) {

    float notas[50], nota;
    int n = 0;
    int pos;

    do {
        cout << "Digite uma nota: ";
        cin >> nota;
        if (nota >= 0) inserirCresc(notas, n, 50, nota);
    } while (nota >= 0);

    listar(notas,n);

    cout << "Procurar qual nota? ";
    cin >> nota;
    pos = buscaBinaria(notas, n, nota);
    if (pos == -1) cout << "Valor nao encontrado!" << endl;
    else cout << "Encontrado na posicao: " << pos << endl;
}

void remover(float v[], int &n, float valor) {
    int i, pos;
    // Verifica se h algum elemento na lista
    if (n == 0) {
        cout << "ERRO: Lista vazia!" << endl;
        return;
    }
    // Encontra posio do elemento a remover
    pos = buscaBinaria(v, n, valor);
    if (pos < 0) {
        cout << "ERRO: Elemento nao encontrado!" << endl;
        return;
    }
    // Remove com sobreposio
    for (i=pos; i<n-1; i++) v[i] = v[i+1];
    // Atualiza quantidade de elementos na lista
    n--;
}

int buscaBinaria(float v[], int n, float valor) {
    // Marca incio e fim
    int ini = 0;
    int fim = n-1;
    int meio;

    while (ini <= fim) {
        meio = (ini+fim)/2;
        if (valor == v[meio]) return meio;
        if (valor < v[meio]) fim = meio-1;
        if (valor > v[meio]) ini = meio+1;
    }

    return -1;
}

void inserirCresc(float v[], int &n, int max, float valor) {
    int i, pos;
    // Verifica se h espao na lista
    if (n == max) {
        cout << "ERRO: Lista cheia!" << endl;
        return;
    }
    // Encontrar posio de insero
    i = 0;
    while (v[i]<valor && i<n) i++;
    pos = i;
    // Move para frente tudo que estiver aps a posio
    for (i=n; i>pos; i--) v[i]=v[i-1];
    // Insere o elemento na posio
    v[pos] = valor;
    n++;
}

void listar(float v[], int n) {
    int i;
    for (i=0; i<n; i++) cout << v[i] << endl;
}

